<?php
/**
 * Plugin Name: SmilePay_PalmboxC2C (Un-Pay)
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay PalmboxC2C UnPay
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 3.2.2
 */
 
/**
 * Check if WooCommerce is active
 */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'smilepaypalmboxc2cup_shipping_method_init', 0);

    //add_action('woocommerce_checkout_update_order_review','Smilepaypalmboxc2cup_shipping_method_match');
    //add_action('before_woocommerce_pay','Smilepaypalmboxc2cup_shipping_method_match_orderpay');
    //配送方式過濾付款方式 重結帳
    /*function Smilepaypalmboxc2cup_shipping_method_match()
    {
        if ( WC()->cart->needs_shipping() ) {
            global $smilepay_load_shipping_method;
            $packages = WC()->cart->get_shipping_packages();
      
            $smilepay_c2cup_service_id = WC_Smilepaypalmboxc2cup_Shipping_Method::getSupport_Service();
            if(!isset($smilepay_load_shipping_method) || $smilepay_load_shipping_method==false)
            {
                foreach ( $packages as $package_key => $package ) 
                {
                    WC()->shipping()->load_shipping_methods( $package );
           
                }
                $smilepay_load_shipping_method =TRUE;
            }
             
            $shipping_methods =  WC()->shipping()->shipping_methods;
            $payment_gateways = WC()->payment_gateways();
           
            foreach($shipping_methods as $shipping_method)
            {
               if(in_array($shipping_method->id,$smilepay_c2cup_service_id) && $shipping_method->get_instance_id() != 0)
               {
                   $smilepay_c2cup_shipping_method =  $shipping_method;
            
                   break;
               }
           
            }
            
            if( isset($smilepay_c2cup_shipping_method) &&  $smilepay_c2cup_shipping_method)
            {
                if($smilepay_c2cup_shipping_method->enabled!="yes")
                    return;
                if($smilepay_c2cup_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                    return;
           
            }
        
            if(isset($_REQUEST['shipping_method'][0] ))
                $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
            else
            {
                $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                if(empty($chosen_methods))
                    return;
                $selected_shipping_method = $chosen_methods[0]; 
            }
                
            foreach ( $payment_gateways as $payment_gateway ) {
                 foreach ( $payment_gateway as $gateway ) {
                        if( in_array(strtolower($selected_shipping_method),$smilepay_c2cup_service_id))
                        {
                            if(!in_array($gateway->id, $smilepay_c2cup_shipping_method->filter_payment) )
                                $gateway->enabled = 'no';
                        }
                 }
            }
        }
    }
    */
    
	function  smilepaypalmboxc2cup_shipping_method_init() {
		if ( ! class_exists( 'WC_Smilepaypalmboxc2cup_Shipping_Method' ) ) {
            
            add_action('woocommerce_after_checkout_validation', 'WC_Smilepaypalmboxc2cup_Shipping_Method::checkout_validate',10,2);
            add_action('woocommerce_after_shipping_rate','WC_Smilepaypalmboxc2cup_Shipping_Method::shipping_emap_region');
            add_action('woocommerce_checkout_order_processed','WC_Smilepaypalmboxc2cup_Shipping_Method::checkout_save_storedata_to_order',10,3);
             add_action( 'wc_ajax_smilepay_palmboxc2cup_save_emap', 'WC_Smilepaypalmboxc2cup_Shipping_Method::ajax_save_emap' );
			class WC_Smilepaypalmboxc2cup_Shipping_Method extends WC_Shipping_Method {
                var $filter_payment;
                const  SERVICE_TEMPERATURE_NORMAL_ID = 'smilepay_palmboxc2cup_normal';
                //const  SERVICE_TEMPERATURE_FRIDGE_ID = 'smilepay_palmboxc2cup_fridge';
                //const  SERVICE_TEMPERATURE_FREEZE_ID = 'smilepay_palmboxc2cup_freeze';
                static $instance_hook_init=0;
                static $support_service=array(self::SERVICE_TEMPERATURE_NORMAL_ID);
                private static $map_url = array(
                                                  'boxtaken'=> array(
                                                                'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=PALMBOXC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                                'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=PALMBOXC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                            ),
                                                );
                private static $map_save_type = array(
                                                    self::SERVICE_TEMPERATURE_NORMAL_ID =>'palmboxc2cup_normal'
                                                );

                protected static $installed_hook=FALSE;
				public function __construct($instance_id = 0) {
					$this->id                 = 'smilepay_palmboxc2cup_shippingunpay';
					$this->method_title       = __( 'SmilePay Palmboxc2cup Shipping(UN-PAY)' ); 
                    
                    
                  
                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->instance_id 			 = absint( $instance_id );
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );
                    $this->method_description    = '速買配掌櫃櫃到櫃純取貨(C2C)';

                    $this->service_id   = array(
                                            'normal' => self::SERVICE_TEMPERATURE_NORMAL_ID,
                                           // 'fridge' => self::SERVICE_TEMPERATURE_FRIDGE_ID,
                                           // 'freeze' => self::SERVICE_TEMPERATURE_FREEZE_ID
                                        );
					
                 
				 
                    

                    $this->title = '速買配 掌櫃櫃到櫃純取貨(C2C)';
                    $this->init();

                    $this->service_name   = array(
                                            'normal' => $this->normal_title,
                                            'fridge' => $this->fridge_title,
                                            'freeze' => $this->freeze_title
                                            );
                    if( empty($this->service_name['normal']))
                        $this->service_name['normal'] ='速買配 掌櫃櫃取貨(C2C)(常溫)';

                   
                    /*if( empty($this->service_name['fridge']))
                        $this->service_name['fridge'] ='速買配 掌櫃櫃取貨(冷藏)';

                    if( empty($this->service_name['freeze']))
                        $this->service_name['freeze'] ='速買配 掌櫃櫃取貨(冷凍)';*/
                       
                    
				}

				public function init_form_fields() {  //後台設置欄位
					
					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
						/*'enabled' => array(
							'title' => __(u2bcu("啟用/關閉"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
              'label' => __(u2bcu("SmilePay 速買配超商宅配"), 'woocommerce'),
						),*/
                     array( 'title' => '掌櫃櫃取貨 常溫設定', 'type' => 'title', 'id' => 'smilepay_palmboxc2cup_normal_title' ),
                        'normal_enabled' => array(
							'title' =>  "櫃取貨(常溫)",
                            'description' => "開啟此功能後，配送方式會多一個掌櫃櫃取貨",
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => "啟用",
						),	
                        'normal_title' => array(
							'title' =>  "配送方式名稱(常溫)",
                            'description' => "前台顯示的配送名稱",
							'type' => 'text',
							'default' => '速買配 掌櫃櫃取貨(常溫)',
                   			'label' => "前台名稱(常溫)",
						),	
                        'fee' => array(
							'title'       => '費用(常溫)',
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                       /* array( 'title' => '掌櫃櫃取貨 冷藏設定', 'type' => 'title', 'id' => 'smilepay_palmboxc2cup_fridge_title' ),
                        'fridge_enabled' => array(
							'title' =>  "櫃取貨(冷藏)",
                            'description' => "開啟此功能後，配送方式會多一個掌櫃櫃取貨冷藏",
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => "啟用",
						),	

                        'fridge_title' => array(
							'title' =>  "配送方式名稱(冷藏)",
                            'description' => "前台顯示的配送名稱",
							'type' => 'text',
							'default' => '速買配 掌櫃櫃取貨(冷藏)',
                   			'label' => "前台名稱(冷藏)",
						),	
                         'fridge_fee' => array(
							'title'       => '費用(冷藏)',
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        array( 'title' => '掌櫃櫃取貨 冷凍設定', 'type' => 'title', 'id' => 'smilepay_palmboxc2cup_freeze_title' ),
                        'freeze_enabled' => array(
							'title' =>  "櫃取貨(冷凍)",
                            'description' => "開啟此功能後，配送方式會多一個掌櫃櫃取貨冷凍",
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => "啟用",
						),	
                        'freeze_title' => array(
							'title' =>  "配送方式名稱(冷凍)",
                            'description' => "前台顯示的配送名稱",
							'type' => 'text',
							'default' => '速買配 掌櫃櫃取貨(冷凍)',
                   			'label' => "前台名稱(冷凍)",
						),	
                        'freeze_fee' => array(
							'title'       => '費用(冷凍)',
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),*/
                        array( 'title' => '掌櫃櫃取貨 共通設定', 'type' => 'title', 'id' => 'smilepay_palmboxc2cup_title' ),
                        'dcvc' => array(
                            'title' => '商家代號',
                            'type' => 'text',
                            'description' =>'請填入您SmilePay商店代號',
                            'default' =>''
                        ),
                        'Rvg2c' => array(
                            'title' => '商家參數碼',
                            'type' => 'text',
                            'description' => '請填入您SmilePay商家參數碼',
                            'default' => ''
                        ),
                        'Verify_key' => array(
                            'title' => '商家檢查碼',
                            'type' => 'text',
                            'description' => '請填入您SmilePay商家檢查碼，檢查碼於商家後台「背景取號API」頁面中，請複製並貼入上方欄位',
                            'default' => ''
                        ),
                        'fee_top' => array(
							'title'       => '免運費門檻',
							'type'        => 'price',
							'description' => "當達到此金額時，免運費，不使用請保持空白",
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => '最低消費金額',
							'type'        => 'price',
							'description' =>'當訂單金額達到此設定金額，才可以使用此配送方式，不含運費',
							'default'     => '',
						),		
                        
						'hiddtext' => array(
							'title' => '掌櫃櫃取貨注意事項',
							'type' => 'hidden',
							'description' => '',
							'default' => ''
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					$this->init_settings();
					$this->fee= $this->get_option( 'fee' );
                    $this->fridge_fee          = $this->get_option( 'fridge_fee' );
                    $this->freeze_fee          = $this->get_option( 'freeze_fee' );
					$this->fee_top= $this->get_option( 'fee_top' );	
                    $this->min_total =$this->get_option('min_total');	
                    //$this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );	
                   
                    $this->normal_enabled = $this->get_option( 'normal_enabled' );
                    //$this->fridge_enabled = $this->get_option( 'fridge_enabled' );
                    //$this->freeze_enabled = $this->get_option( 'freeze_enabled' );

                    $this->normal_title = $this->get_option( 'normal_title' );
                   // $this->fridge_title = $this->get_option( 'fridge_title' );
                    //$this->freeze_title = $this->get_option( 'freeze_title' );

                    $this->dcvc = $this->get_option( 'dcvc' );
                    $this->Rvg2c = $this->get_option( 'Rvg2c' );
                    $this->Verify_key = $this->get_option( 'Verify_key' );
                    //$this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );
                    
                    add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
					
					if(!self::$installed_hook)
					{
                        if($this->instance_id >0 &&  $this->enabled == 'yes' )
                        {
                           //add_action('woocommerce_after_checkout_validation', array( $this, 'checkout_validate' ),10,2);
                            
                            
                            //add_action( 'woocommerce_checkout_order_processed', array($this,'create_smilepay_order_process'),10,3 );
                            //self::$instance_hook_init =1;
                           
                        }
                       
                        add_action( 'woocommerce_thankyou', array($this,'checkout_thank_you' ));
                        self::$installed_hook=TRUE;
                    }
				}

                //save emap
                static function ajax_save_emap()
                {
                    global $woocommerce;
                    $checkout_url = wc_get_checkout_url();
                    $store_data=array();
                    if(isset($_REQUEST['storeid']))
                        $store_data['storeid']=$_REQUEST['storeid'];
                    if(isset($_REQUEST['storename']))
                        $store_data['storename']=$_REQUEST['storename'];
                    if(isset($_REQUEST['storeaddress']))
                        $store_data['storeaddress']=$_REQUEST['storeaddress'];
                    if(isset($_REQUEST['type']))
                        $store_data['type']=$_REQUEST['type'];
                    
                    self::checkout_save_storedata($store_data);
                    wp_redirect($checkout_url);
                    die();
                }

                //hook sava order store data
                static function checkout_save_storedata_to_order($order_id, $posted_data, $order)
                {

                    if(empty($order))
                        $order = new WC_Order($order_id);

                    $shipping_method = @array_shift($order->get_shipping_methods());
                    $shipping_method_id = $shipping_method['method_id'];
                    if(self::isSupport_Service($shipping_method_id))
                    {
                        $store_data=self::checkout_load_storedata();
                        self::save_storedata_by_orderid($order_id,$store_data);
                        self::checkout_clear_store_data();
                        $msg= '門市：'.$store_data['storename'].'('.$store_data['storeid'].')<br>'."地址：".$store_data['storeaddress'];
                        $order->add_order_note( $msg,"1");
                        $order->set_shipping_address_1($store_data['storeaddress']);
                        $order->save();
                    }
                    
                }
                //show emap
                static function shipping_emap_region($method)
                {
                    global $woocommerce;

                    $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                    
                    if(!empty($chosen_methods) && $chosen_methods[0] == $method->id && self::isSupport_Service($method->id)) 
                    {

                        $ret_url =   get_site_url() ."?wc-ajax=smilepay_palmboxc2cup_save_emap"."&type=".self::$map_save_type[$method->id ] ;
                        $emap_url=self::getCSVMapUrl( $method->id,$ret_url,'');
                        $store_data=self::checkout_load_storedata();
                        echo "<button type='button' onclick='window.open(\"".$emap_url."\",\"_self\");'>取貨門市</button>";

                        if(self::checkout_is_selected_emap($method->id))
                        {
                            echo '<div>取貨門市：<span style="color:blue;">'.$store_data['storename'].'('.$store_data['storeid'].')<br>'.$store_data['storeaddress'] .'</span></div>';
                        }


                    }
                   
                        
                }
                public static function getCSVMapUrl($method_id,$ret_url,$note='')
                {
                    $useragent=$_SERVER['HTTP_USER_AGENT'];
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                         {
                                if( preg_match('/Android|iPad|iPhone/i',$useragent)  )
                                {
                                    return sprintf(self::$map_url['boxtaken']['mobile'],$note,urlencode($ret_url));
                                }
                                else
                                {
                                    return sprintf(self::$map_url['boxtaken']['normal'],$note,urlencode($ret_url));
                                }
                         }
                     }
                     
                }

                public static function getSupport_Service()
                {
                     return self::$support_service;
                }

                static function checkout_save_storedata($store_data)
                {
                    if(isset($store_data['storeid']))
                         WC()->session->set( 'smilepay_palmboxc2cup_storeid',$store_data['storeid'] );
                    if(isset($store_data['storename']))
                         WC()->session->set( 'smilepay_palmboxc2cup_storename',$store_data['storename'] );
                    if(isset($store_data['storeaddress']))
                         WC()->session->set( 'smilepay_palmboxc2cup_storeaddress',$store_data['storeaddress'] );
                    if(isset($store_data['type']))
                         WC()->session->set( 'smilepay_palmboxc2cup_type',$store_data['type'] );

                }
                
                static function checkout_load_storedata()
                {
                    $store_data =array();
                    
                    $store_data['storeid']= WC()->session->get( 'smilepay_palmboxc2cup_storeid' );
                    $store_data['storename']= WC()->session->get('smilepay_palmboxc2cup_storename' );
                    $store_data['storeaddress']= WC()->session->get( 'smilepay_palmboxc2cup_storeaddress' );
                    $store_data['type'] = WC()->session->get( 'smilepay_palmboxc2cup_type' );
                    return $store_data;
                }

                static function checkout_clear_store_data()
                {
                    WC()->session->__unset( 'smilepay_palmboxc2cup_storeid' );
                    WC()->session->__unset( 'smilepay_palmboxc2cup_storename' );
                    WC()->session->__unset( 'smilepay_palmboxc2cup_storeaddress' );
                    WC()->session->__unset( 'smilepay_palmboxc2cup_type' );
                }

                static function checkout_is_selected_emap($method_id)
                {
                    $store_data= self::checkout_load_storedata();
                    if(isset($store_data['type']) && $method_id == 'smilepay_'. $store_data['type'] )
                    {
                        if(!empty($store_data['storeid'])&& !empty($store_data['storename'])&& !empty($store_data['storeaddress']))
                            return true;
                    }
                    return false;
                }

                function save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    self::_save_storedata_by_orderid($order_id,$store_data);
                }

                function load_storedata_by_orderid($order_id=0)
                {
                    return self::_load_storedata_by_orderid($order_id);
                }

                static function _save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    if(!empty($order_id))
                    {
                        if( isset($store_data['storeid'])&&isset($store_data['storename'])&&isset($store_data['storeaddress'])){
                            $data=$store_data['storeid'] .'/'.$store_data['storename'] .'/'.$store_data['storeaddress'];
                            update_post_meta( $order_id, 'smilepay_palmboxc2cup_storedata',$data );
                        }
                            
                    }
                }

                function _load_storedata_by_orderid($order_id=0)
                {
                    if(!empty($order_id))
                    {
                        $data=get_post_meta( $order_id, 'smilepay_palmboxc2cup_storedata',true);
                        $storedata_tmp=explode('/',$data);
                      
                        if(count($storedata_tmp)!=3)
                        {
                            $store_data['storeid']='';
                            $store_data['storename']=''; 
                            $store_data['storeaddress']='';
                        }
                        else
                        {
                            $store_data['storeid']=$storedata_tmp[0];
                            $store_data['storename']=$storedata_tmp[1]; 
                            $store_data['storeaddress']=$storedata_tmp[2];
                        }
                        
                        return $store_data;
                        
                    }
                    return NULL;
                }
                function is_selected_emap_by_order_id($order_id)
                {
                    $store_data= $this->load_storedata_by_orderid($order_id);
                    
                    if(!empty($store_data['storeid'])&& !empty($store_data['storename'])&& !empty($store_data['storeaddress']))
                        return true;
                    
                    return false;
                }
                function checkout_thank_you($order_id)
                {
                    $store_data =$this->load_storedata_by_orderid($order_id);
                    $order = new WC_Order($order_id);
                    $shipping_method = @array_shift($order->get_shipping_methods());
                    $shipping_method_id = $shipping_method['method_id'];
                    if(self::isSupport_Service($shipping_method_id))
                    {
                        echo '<div><h2>掌櫃門市資訊</h2>取貨門市:'.$store_data['storename'] .' ('. $store_data['storeid']. ')<br>門市地址:'.$store_data['storeaddress'];
                        echo '<br><br><span style="color:red;">請注意掌櫃取貨簡訊，包裹到店後須在72小時內領取，否則「取件碼」會失效，且視為「逾期未取」開始退回包裹。</span>';
                        echo '</div>';
                    }
                }
                

                static function checkout_validate( $data, $errors )
                {
                   if ( WC()->cart->needs_shipping() ) {
                        $chosen_shipping_methods = WC()->session->get( 'chosen_shipping_methods' );
                        $chosen_payment_method = WC()->session->get( 'chosen_payment_method' ); 
                        $find_shipping_method=FALSE;
                        foreach($chosen_shipping_methods as $shipping_method)
                        {
                            if(self::isSupport_Service($shipping_method))
                            {
                                $find_shipping_method=TRUE;
                                if(!self::checkout_is_selected_emap($shipping_method))
                                {
                                     $errors->add( 'shipping',"取貨門市未選擇");
                                }
                            }

                            
                        }
                        if( $find_shipping_method)
                        {
                        
				            if(substr($data['billing_phone'],0,2)!="09" || mb_strlen($data['billing_phone'])!=10){
                               $errors->add( 'shipping',"<br>電話格式錯誤，範例09XX123456(共10碼)。");
                   
				            }
                            
                            /*if(!in_array($chosen_payment_method,$this->filter_payment) )
                            {
                               $errors->add( 'shipping',u2bcu("<br>付款方式選擇錯誤，此配送方式不可選該付款方式，請更換其一<br>"));
                            }*/
                        }
                   }

                }
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$fee_top=$this->fee_top;
				    $total = WC()->cart->cart_contents_total;	
                    	
					if($this->normal_enabled == "yes")
                    {
                        $shipping_total=$this->fee;	
                        //if(isset($outside_fee))
                         //   $shipping_total += $outside_fee;
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['normal'],
						    'label' =>$this->service_name['normal'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }

					/*if($this->fridge_enabled == "yes")
                    {
                        $shipping_total=$this->fridge_fee;
                        //if(isset($outside_fee))
                          //  $shipping_total += $outside_fee;			
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['fridge'],
						    'label' =>$this->service_name['fridge'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }
                    
                    if($this->freeze_enabled == "yes")
                    {
                        $shipping_total=$this->freeze_fee;	
                        //if(isset($outside_fee))
                           // $shipping_total += $outside_fee;		
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['freeze'],
						    'label' =>$this->service_name['freeze'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }   */
				}
                // 是否選用palmboxc2cup運送
                // $order_id:訂單編號
                public function isSelectedSmilepaypalmboxc2cup($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
            
                    $order = new WC_Order($order_id);
          
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;

		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }
                         
		                foreach ( $shipping_methods as $shipping_method ) {                         
                                if ( in_array($shipping_method->get_method_id(),$this->service_id)  ) {
				                    return true;
			                    }
		                }
                        return FALSE;

                    }
                    else
                    {

                        foreach($this->service_id as $service_id)
                        {
                            if( $order->has_shipping_method($service_id ))
                                return true;
                        }

                        return false;
                    }
                 }
                 public function create_smilepay_order($order_id)
                 {
                    $order = new WC_Order($order_id);

                    if($order->has_shipping_method(self::SERVICE_TEMPERATURE_NORMAL_ID))
                        $temperature="0";
                    /*elseif($order->has_shipping_method(self::SERVICE_TEMPERATURE_FRIDGE_ID))
                        $temperature="0002";
                    elseif($order->has_shipping_method( self::SERVICE_TEMPERATURE_FREEZE_ID))
                        $temperature="0003";
                    else
                        $temperature="0001";*/

                    /*$address = "";
                    $address .= trim($order->get_shipping_city());
                    $address .= trim($order->get_shipping_state());
                    $address .= trim($order->get_shipping_address_1());
                    $address .= trim($order->get_shipping_address_2());*/
                    //<SmilePay>item add start
                    /*$products="";
                    foreach ($order->get_items() as $key => $lineItem) {
                        $products .= $lineItem['name'] ."*" .$lineItem['quantity'] .",";
            
                    }
                    $products=trim($products,",");*/
                    //<SmilePay>item add end
                    if(!$this->is_selected_emap_by_order_id($order_id))
                    {
                        $result = array(
                                'Status' => '-10100',
                                'Desc' =>  '門市未選擇'
                            );
                            return $result; 
                    }

                    $pur_name = $order->get_shipping_last_name() . $order->get_shipping_first_name();
                    $store_data = $this->load_storedata_by_orderid($order_id);
                    $logistic_store = $store_data['storeid'].'/'.$store_data['storename'].'/'.$store_data['storeaddress'];
                   

			        $smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';
			        $post_strall='Dcvc=' . $this->dcvc .
						        '&Pay_zg=52' .
                                '&Pay_subzg=PBOX' .
						        '&Rvg2c=' .  $this->Rvg2c .
                                '&Verify_key=' . $this->Verify_key.
						        '&Od_sob=' . $order_id .
						        '&Pur_name=' .urlencode($pur_name ).
						        '&Mobile_number=' .urlencode($order->get_billing_phone()).
						        '&Email=' .urlencode($order->get_billing_email()).
						        '&Data_id=' . $order_id .
						        '&Amount=' . intval(round($order->get_total())) .
                                '&Logistics_store='. urlencode($logistic_store).
						        //'&Roturl_status=' . 'woook'.
						        //'&Roturl=' . $Vk.
						        //'&MapRoturl=' . urlencode($URL).
                                "&Temperature=". $temperature .
						        '&Remark=woocommerce';
                                //<SmilePay>item add start
					            //'&Remark='. $products;
                                //<SmilePay>item add end
                                
                    $ch = curl_init();
			        curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			        curl_setopt($ch, CURLOPT_VERBOSE, 1);
			        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			        curl_setopt($ch, CURLOPT_POST, 1);
			        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_strall);
			        $string = curl_exec($ch);
			        curl_close($ch);
                    $xml = simplexml_load_string($string);
			        $Status = $xml->Status;
                   
                    if($xml !== false)
                        return (array)$xml;
                    else
                        return  $string;
                 }


                 public function create_smilepay_order_process($order_id, $posted_data, $order)
                 {
                     if($this->isSelectedSmilepaypalmboxc2cup($order_id))
                     { 
                        
                        //$order = new WC_Order($order_id);
                        $result = $this->create_smilepay_order($order_id);
                        if(!is_array( $result))
                        {
                             $result = array(
                                'Status' => '-10000',
                                'Desc' =>  'response empty or connect fail'
                            );
                            return $result; 
                            //$order->update_status('cancelled');
                        }
			            elseif(isset($result['Status']) && $result['Status']=="1")
			            {
                            $T_Smseid = $result['SmilePayNO'];
                            $ordertext = "速買配掌櫃櫃取貨<br>請勿刪除此資訊，速買配SmilePay追蹤碼：".$T_Smseid;
                            //update_post_meta( $order_id, 'smilepay_ezcatp_smseid', $T_Smseid )	;

                            self::set_order_smseid($order_id, $T_Smseid);

                            $order->add_order_note($ordertext,"0");
                            //$order->update_status('on-hold');		
                        }
                        else
                        {
                            /*$T_Smseid = $result['SmilePayNO'];
                            $ordertext = "訂單成立失敗，錯誤碼：". $result['Status'] ."錯誤描述：".$result['Desc'];
                            $order->add_order_note($ordertext,"0");*/
                            //$order->update_status('cancelled');
                            //$error_message= "<span style='color:red;'>" .  $this->title . "訂單成立失敗，請與商家聯繫" ."</span>";
                            //$order->add_order_note($error_message,"1");
                        }
                         
                     }
                     else
                     {
                         return array(
                                    'Status'=> '-10009',
                                    'Desc' => 'shipping_method error'
                                );
                     }
                     return $result;
                 }

                 public static function isSupport_Service($method_id)
                 {
                     if(in_array($method_id,self::$support_service))
                        return TRUE;
                     return FALSE;
                 } 

                 public static function getOrderSmilepaypalmboxc2cupPlugin($order_id)
                 {
                    $order = new WC_Order($order_id);    
                     //make fake package for find shipping region
                    $packages = array();
                    $packages['destination']['country']   =  $order->get_shipping_country();
		            $packages['destination']['state']     =  $order->get_shipping_state();
		            $packages['destination']['postcode']  =  $order->get_shipping_postcode();
		            $packages['destination']['city']      =  $order->get_shipping_city();
		            $packages['destination']['address']   =  $order->get_shipping_address_1();
		            $packages['destination']['address_2'] =  $order->get_shipping_address_2();
                    $zone = WC_Shipping_Zones::get_zone_matching_package($packages);
                    $shipping_methods = $zone->get_shipping_methods(true);
                   
                    foreach($shipping_methods as $shipping_method)
                    {
                        
                        if($shipping_method->id=='smilepay_palmboxc2cup_shippingunpay' )
                        {
                            return $shipping_method;  
                        }
                    }
                    return NULL;
                 }

                 public static function api_process()
                 {
                    $order_url = get_admin_url().'edit.php?post_type=shop_order';
           
                    if(!isset($_REQUEST['api_action']))
                    {
                        return FALSE;
                    }
                    else
                        $action =  $_REQUEST['api_action'] ;

                    if( $action ==  'create_order')
                    {
                        if(isset($_REQUEST['post']))
                            $order_id = $_REQUEST['post'];
                        else
                            $order_id = 0;

                        $order_url =  get_admin_url()."post.php?post=$order_id&action=edit";


                        $smilepaypalmboxc2cup_plug = self::getOrderSmilepaypalmboxc2cupPlugin($order_id);
                        if($smilepaypalmboxc2cup_plug != null)
                        {
                            $order = new WC_Order($order_id);   
                            $smseid = self::get_order_smseid($order_id); 
                            if(empty($smseid))
                            {
                               $result =  $smilepaypalmboxc2cup_plug->create_smilepay_order_process($order_id,NULL,$order);
                                if($result['Status'] != "1")
                                {
                                    $errormsg = 'order 錯誤碼:'. $result['Status'] . "<br>錯誤描述:".$result['Desc'];
                                    setcookie("smilepay_palmboxc2cup_admin_shipping_error", $errormsg, time()+30);
                                    wp_redirect($order_url);
                                    die();
                                } 
                            }
                               
                            
                            //$tracknum =  self::get_order_tracknum($order_id);
                            $checkcode =  self::get_order_checkcode($order_id);
                            $sp_size = $_REQUEST['sp_size'];
                           
    
                            if(empty($checkcode))
                            {
                                $result_shipping = $smilepaypalmboxc2cup_plug->create_smilepay_shipping_process($order_id,$sp_size);

                              
                                if($result_shipping['Status'] != "1")
                                {
                                    $errormsg = 'shipping 錯誤碼:'. $result_shipping['Status'] . "<br>錯誤描述:".$result_shipping['Desc'];
                                    setcookie("smilepay_palmboxc2cup_admin_shipping_error", $errormsg, time()+30);
                                    wp_redirect($order_url);
                                    die();
                                }
                            }
                            
                            
                            wp_redirect($order_url);
                            die();
                        }
                        
                    }
                    
                }

                public function create_smilepay_shipping_order($order_id,$box_size)
                {
                    $order = new WC_Order($order_id);

           
                   
                    $packagea_size = $box_size;

                    $smseid = self::get_order_smseid($order_id); 
                    if( empty($smseid))
                    {
                        $result = array(
                                'Status' => '-10202',
                                'Desc' =>  'No Smseid Re-run the Process.'
                            );
                        return $result; 
                    }
                    $post_data = array();
                    $post_data['Dcvc'] =  trim( $this->dcvc);
                    $post_data['Rvg2c'] = trim($this->Rvg2c);
                    $post_data['Verify_key'] = trim($this->Verify_key);
                    $post_data['smseid'] = $smseid;
                    $post_data['Package_size'] = $packagea_size;
                    
                  
                                     
			        $smilepay_gateway = 'https://ssl.smse.com.tw/api/pbGetCheckCode.asp';
			      
                                
                    $ch = curl_init();
			        curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			        curl_setopt($ch, CURLOPT_VERBOSE, 1);
			        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			        curl_setopt($ch, CURLOPT_POST, 1);
			        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post_data,'','&'));
			        $string = curl_exec($ch);
			        curl_close($ch);
                    $xml = simplexml_load_string($string);
			        $Status = $xml->Status;
                   
                    if($xml !== false)
                        return (array)$xml;
                    else
                        return  $string;
                }

                public function create_smilepay_shipping_process($order_id,$box_size)
                {
                    if($this->isSelectedSmilepaypalmboxc2cup($order_id))
                    { 
                        
                        $order = new WC_Order($order_id);
                        $result = $this->create_smilepay_shipping_order($order_id,$box_size);
                        if(!is_array( $result))
                        {
                            //$ordertext= "<span style='color:red;'>" .'連線未如預期，請稍後嘗試，若持續無法解決請與廠商聯繫'."</span>";
                            //$order->add_order_note($ordertext,"0");
                            //$order->update_status('cancelled');
                             $result = array(
                                'Status' => '-10000',
                                'Desc' =>  'response empty or connect fail'
                            );
                            return $result; 
                        }
			            elseif(isset($result['Status']) && $result['Status']=="1")
			            {
                            $checkcode = $result['CheckCode'];
                            $ordertext = "速買配掌櫃櫃取貨<br>請勿刪除此資訊，掌櫃寄件碼：".$checkcode;
                            //update_post_meta( $order_id, 'smilepay_ezcatp_smseid', $T_Smseid )	;

                            self::set_order_checkcode($order_id, $checkcode);

                            $order->add_order_note($ordertext,"0");
                            //$ordertext_customer = "掌櫃櫃取貨託運單號：".$tracknum;
                            //$order->add_order_note($ordertext_customer,"1");
                            //$order->update_status('on-hold');		
                        }
                        else
                        {
                            /*$T_Smseid = $result['SmilePayNO'];
                            $ordertext = "訂單成立失敗，錯誤碼：". $result['Status'] ."錯誤描述：".$result['Desc'];
                            $order->add_order_note($ordertext,"0");
                            */
                        }
                         
                     }
                     else
                     {
                         return array(
                                    'Status'=> '-10009',
                                    'Desc' => 'shipping_method error'
                                );
                     }
                     return $result;
                }


                public static function get_order_smseid($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_palmboxc2cup_SMSEID', true );
                }
                public static function set_order_smseid($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_palmboxc2cup_SMSEID', $smseid );
                }

                public static function get_order_tracknum($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_palmboxc2cup_TRACKNUM', true );
                }
                public static function set_order_tracknum($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_palmboxc2cup_TRACKNUM', $smseid );
                }

                public static function get_order_checkcode($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_palmboxc2cup_CHECKCODE', true );
                }
                public static function set_order_checkcode($order_id,$checkcode)
                {
                    return update_post_meta( $order_id, 'Smilepay_palmboxc2cup_CHECKCODE', $checkcode );
                }
			}
		}


        if(is_admin())
        {
            global $pagenow;
            add_action('admin_notices', 'smilepay_palmboxc2cup_shipping_error_show' );
            add_action('admin_menu','addAdminMenuSmilepaypalmboxc2cup',50);
           
           


            if($pagenow=='post.php' && $_GET['Page']=='smilepay_palmboxc2cup_shipping_gen')
            {
                add_action('init', 'smilepay_palmboxc2cup_shipping_gen');
            }
        }

	}

    
	add_action( 'woocommerce_shipping_init', 'smilepaypalmboxc2cup_shipping_method_init' );

    function addAdminMenuSmilepaypalmboxc2cup()
    {
         add_submenu_page('','smilepay_palmboxc2cup_api', '速買配掌櫃櫃取貨Api', 'administrator', 'smilepay_palmboxc2cup_api','WC_Smilepaypalmboxc2cup_Shipping_Method::api_process');
    }

	function add_smilepaypalmboxc2cup_shipping_method( $methods ) {

        //for woocommerce 2.6 modify
		$methods['smilepay_palmboxc2cup_shippingunpay'] = 'WC_Smilepaypalmboxc2cup_Shipping_Method';
		return $methods;
	}

    
    function smilepay_palmboxc2cup_shipping_error_show()
    {
        $error="";
        if(isset($_COOKIE['smilepay_palmboxc2cup_admin_shipping_error']))
        {
             $error= $_COOKIE['smilepay_palmboxc2cup_admin_shipping_error'];
             unset($_COOKIE['smilepay_palmboxc2cup_admin_shipping_error']);
             setcookie('smilepay_palmboxc2cup_admin_shipping_error', '', time() - 30 ); 
        }
      
            
        if($error)
        {
            echo "<div class='notice notice-error'><p>$error</p></div>";
        }

    }

    function smilepay_palmboxc2cup_menu_init_data()
    {     
        if(is_admin())
        {
            add_action( 'add_meta_boxes', 'smilepaypalmboxc2cup_order_add_meta_boxes' , 35 );            
        }      
    }

    function smilepaypalmboxc2cup_order_add_meta_boxes() {
	    $screen    = get_current_screen();
	    $screen_id = $screen ? $screen->id : '';

        
        if($screen->post_type == 'shop_order' && class_exists('WC_Smilepaypalmboxc2cup_Shipping_Method'))
        {
            if(isset($_REQUEST['post']))
                $order_id = $_REQUEST['post'];
            else
                $order_id = 0;

            if( empty($order_id))
                return;
            $order = new WC_Order($order_id);
           
            $shipping_method = @array_shift($order->get_shipping_methods());
            $shipping_method_id = $shipping_method['method_id'];
           
            if(WC_Smilepaypalmboxc2cup_Shipping_Method::isSupport_Service( $shipping_method_id) )
                add_meta_box( 'smilepaypalmboxc2cup-order-data', "速買配掌櫃櫃取貨", 'smilepaypalmboxc2cup_order_output', 'shop_order', 'normal', 'low' );
        }
            
    }

    function smilepaypalmboxc2cup_order_output()
    {
        if(isset($_REQUEST['post']))
            $order_id = $_REQUEST['post'];
        else
            $order_id = 0;

        if( !$order_id)
           return;

        $smilepaypalmboxc2cup_plug = WC_Smilepaypalmboxc2cup_Shipping_Method::getOrderSmilepaypalmboxc2cupPlugin($order_id);
       
        if( $smilepaypalmboxc2cup_plug != null)
            include_once('tpl/admin/html_smilepaypalmboxc2cup_order_meta_box_admin.php');
        else
            echo '未知錯誤';
    }


    add_action('add_meta_boxes','smilepay_palmboxc2cup_menu_init_data', 10);
    
	add_filter( 'woocommerce_shipping_methods', 'add_smilepaypalmboxc2cup_shipping_method' );
}


   